#include "stdafx.h"
#include "resource.h"
#include "windows.h"
#include "tr3.h"
#include "commctrl.h"  
#define  APSTUDIO_INVOKED
#include "resource.h"  
typedef struct tagSUBDIALOGS
{
    UINT          id;
    HWND          hSource;
    RECT          rectSource;
} SUBDIALOGS;

void MoveChildWindows(HWND hWnd)
{
    SUBDIALOGS    dloc[11] = 
    {
        IDC_FRAME1,NULL,0,0,0,0,                           //
        IDC_FRAME11,NULL,0,0,0,0,                          //
        IDC_FRAME3,NULL,0,0,0,0,                           //
        IDC_FRAME7,NULL,0,0,0,0,                           //
        IDC_FRAME9,NULL,0,0,0,0,                           //
        IDC_FRAME13,NULL,0,0,0,0,                          //
        IDC_OUTERDESKFRAME,NULL,0,0,0,0,                   //
        IDC_FRAMETESTING,NULL,0,0,0,0,                     //
        IDC_FRAMEBETA,NULL,0,0,0,0,                        //
        IDC_FRAME14,NULL,0,0,0,0,                          //
        IDC_FRAME15,NULL,0,0,0,0
    } 
    ;

    HWND          hTabControl;
    TCITEM        tc;
    RECT          rect;
    int           x,y,sourceFrame,controlNumber;
    POINT         pt = 
    {
        0,0
    } 
    ;
 // Set up Tabs and do misc inits

    SetWindowText(ItemHWnd(ID_WEBPAGE), "Web Page");
    SetWindowText(ItemHWnd(ID_FAQ), "FAQ");
    tc.mask = TCIF_TEXT;
    tc.pszText = "Colors";
    SendMessage(hTabControl = ItemHWnd(ID_TABBOX), TCM_INSERTITEM, TABCOLORS, (LPARAM)&tc);
    tc.pszText = "Hiding";
    SendMessage(hTabControl, TCM_INSERTITEM, TABHIDING, (LPARAM)&tc);
    tc.pszText = "Positions";
    SendMessage(hTabControl, TCM_INSERTITEM, TABPOS, (LPARAM)&tc);
    tc.pszText = "Tray";
    SendMessage(hTabControl, TCM_INSERTITEM, TABTRAY, (LPARAM)&tc);
    tc.pszText = "Options";
    SendMessage(hTabControl, TCM_INSERTITEM, TABOPTIONS, (LPARAM)&tc);
    tc.pszText = "Desktop";
    SendMessage(hTabControl, TCM_INSERTITEM, TABDESKTOP, (LPARAM)&tc);
    tc.pszText = "About";
    SendMessage(hTabControl, TCM_INSERTITEM, TABABOUT, (LPARAM)&tc);
//  ------------------------------------
    for (sourceFrame = 0; sourceFrame < 11; sourceFrame++)
    {
        dloc[sourceFrame].hSource = ItemHWnd(dloc[sourceFrame].id);
        GetWindowRect(dloc[sourceFrame].hSource, &dloc[sourceFrame].rectSource);
    } 
    ClientToScreen(hWnd, &pt);

    for (sourceFrame = 1; sourceFrame < 11; sourceFrame++)
    {
        RECT          rectDest;
        RECT          rectCtl;
        POINT         ptCtl;
        HWND          hKid;
          
        GetWindowRect(ItemHWnd(IDC_FRAME1), &rectDest);
        for (controlNumber = 1000; controlNumber < (_APS_NEXT_CONTROL_VALUE); controlNumber++)
        {
            RECT          rectSource;
          
            CopyRect(&rectSource, &dloc[sourceFrame].rectSource);
            if (GetWindowRect(hKid = ItemHWnd(controlNumber), &rectCtl))
            {
                ptCtl.x = rectCtl.left;
                ptCtl.y = rectCtl.top;
                if (PtInRect(&rectSource, ptCtl))
                {
                    x = rectDest.left-rectSource.left-pt.x;
                    y = rectDest.top-rectSource.top-pt.y;
                    OffsetRect(&rectCtl, x, y);
                    MoveWindow(hKid, rectCtl.left, rectCtl.top, rectCtl.right-rectCtl.left, rectCtl.bottom-rectCtl.top, TRUE);
                    ShowWindow(hKid, SW_HIDE);
                } 
            } 
        } 
    } 
//      --------------------------------------------------------

    GetClientRect(ItemHWnd(ID_TABBOX), &rect);
    SendMessage(ItemHWnd(ID_TABBOX), TCM_ADJUSTRECT, FALSE, (LPARAM)&rect);
    MoveWindow(ItemHWnd(IDC_ABOUTBKG), rect.left+4, rect.top+1, rect.right-rect.left+1, rect.bottom-rect.top+1, FALSE);
    SetWindowText(ItemHWnd(IDC_ABOUTBKG), "");

} 

VOID ReInitializeControlSettings(HWND hWnd)
{
    HWND          hTemp;
    static int    hCornerId[4] = 
    {
        ID_UL,ID_UR,ID_LL,ID_LR
    } 
    ;
 // Initialize the check boxes based on icSettings (saved settings)
    if (icSettings.bAutoHide&icSettings.bAlwaysHide)
    {
        icSettings.bAutoHide = FALSE;
        icSettings.bAlwaysHide = FALSE;
    } 
    CheckDlgButton(hWnd, ID_CHKAUTO, icSettings.bAutoAuto);
    CheckDlgButton(hWnd, ID_COMPLIMENT, icSettings.bCompliment);
    CheckDlgButton(hWnd, ID_IGNORESOLIDBORDER, icSettings.bIgnoreBorder);
    CheckDlgButton(hWnd, ID_SAMPWHOLE, icSettings.bSampWhole);
    CheckDlgButton(hWnd, ID_CHKAUTOHIDE, icSettings.bAutoHide);
    CheckDlgButton(hWnd, IDC_HIDECURSOR, icSettings.bCursorHide);
    CheckDlgButton(hWnd, ID_HIDETASKBAR, icSettings.bHideTaskBar);
    CheckDlgButton(hWnd, ID_CHKALWAYSHIDE, icSettings.bAlwaysHide);
    CheckDlgButton(hWnd, ID_CHKNEVERHIDE, !(icSettings.bAlwaysHide|icSettings.bAutoHide));
    CheckDlgButton(hWnd, ID_CHKONDESKTOP, icSettings.bOnDesktop);
    CheckDlgButton(hWnd, ID_CHKOFFDESKTOP, icSettings.bOffDesktop);
    CheckDlgButton(hWnd, ID_CHKSHOWDELAY, icSettings.bShowDelay);
    CheckDlgButton(hWnd, IDC_TEMPSHOWTXT, icSettings.bShowIconsInAlways);
    CheckDlgButton(hWnd, ID_OPTTRANSPARENT, icSettings.bTransparent);
    CheckDlgButton(hWnd, ID_OPTSOLID, !icSettings.bTransparent);
    CheckDlgButton(hWnd, ID_AUTOFG, icSettings.bAutoFG);
    CheckDlgButton(hWnd, ID_CHKCONFIRMEXIT, icSettings.bConfirmExit);
    CheckDlgButton(hWnd, ID_CHKAUTOSTART, icSettings.bAutoStart);
    CheckDlgButton(hWnd, IDC_FADE, icSettings.bFade);
    CheckDlgButton(hWnd, IDC_CONTEXTMENU, icSettings.bContextMenu);
    CheckDlgButton(hWnd, ID_CHKTWOSEC, icSettings.bTwoSecondWait);
    CheckDlgButton(hWnd, ID_BOSS, icSettings.bBoss);
    SendMessage(ItemHWnd(ID_HIDECOMBO), CB_SETCURSEL, icSettings.iHideMethod, 0);
    CheckDlgButton(hWnd, ID_CHKHOTCORNER, icSettings.bHotCorner);
    CheckDlgButton(hWnd, ID_CHKHIDEATSTART, icSettings.bHideWhenStarted);
    CheckDlgButton(hWnd, ID_CHKSHOWHIDINGOPTIONS, icSettings.bShowHidingOptions);
    CheckDlgButton(hWnd, ID_CHKSHOWBACKGROUNDOPTIONS, icSettings.bShowIconBackgroundOptions);
    CheckDlgButton(hWnd, ID_CHKSHOWHELP, icSettings.bShowHelp);
    CheckDlgButton(hWnd, ID_CHKSAVEREST, icSettings.bShowSaveRest);
    CheckDlgButton(hWnd, ID_AUTORESTORE, icSettings.bAutoRestore);
    CheckDlgButton(hWnd, IDC_POSBYRES, icSettings.bAbsolutePosition);
    CheckDlgButton(hWnd, IDC_POSRELATIVE, !icSettings.bAbsolutePosition);
    CheckDlgButton(hWnd, IDC_CHKSTATUSBAR, icSettings.bStatusBar);
    CheckDlgButton(hWnd, ID_NEVEREND, icSettings.bNeverEnd);
    CheckDlgButton(hWnd, IDC_NORMALIZE, icSettings.bNormalize);

    CheckDlgButton(hWnd, IDC_TRAYDANCE, icSettings.bShowDance);
    CheckDlgButton(hWnd, ID_EXITEXIT, !(icSettings.bNeverEnd || icSettings.bConfirmExit));

    icSettings.bTrayIcon = (icSettings.bTrayIcon || !bHotKeyIsActive);
    CheckDlgButton(hWnd, ID_CHKTASKBAR, icSettings.bTrayIcon);
    CheckDlgButton(hWnd, ID_UL, FALSE);
    CheckDlgButton(hWnd, ID_UR, FALSE);
    CheckDlgButton(hWnd, ID_LL, FALSE);
    CheckDlgButton(hWnd, ID_LR, FALSE);
    CheckDlgButton(hWnd, hCornerId[icSettings.cornernum], TRUE); // Set the hot corner radio button
 // Initialize the Scroll bars based on icSettings (saved settings)

    EnableWindow(ItemHWnd(ID_FGCOLOR), FALSE);
    EnableWindow(ItemHWnd(ID_BKCOLOR), FALSE);
//    EnableWindow(ItemHWnd(ID_AUTOFG), !icSettings.bTransparent);
    EnableWindow(ItemHWnd(ID_CHKAUTO), !icSettings.bTransparent && !IsActiveDesktop());

    EnableWindow(ItemHWnd(ID_CHKTASKBAR), bHotKeyIsActive);
//    SetWindowText(ItemHWnd(IDC_LBLINSTR), "Left Click..... Color Box\nRight Click... From Desktop");
    SendMessage(hTemp = ItemHWnd(ID_SCROFFDESKTOP), TBM_SETRANGE, FALSE, MAKELONG(0, 60));
    SendMessage(hTemp, TBM_SETPOS, TRUE, icSettings.tmrOffDesktop);
    SendMessage(hTemp, TBM_SETPAGESIZE, 0, 1);

    SendMessage(hTemp = ItemHWnd(ID_SCRONDESKTOP), TBM_SETRANGE, FALSE, MAKELONG(0, 60));
    SendMessage(hTemp, TBM_SETPOS, TRUE, icSettings.tmrOnDesktop);
    SendMessage(hTemp, TBM_SETPAGESIZE, 0, 1);

    SendMessage(hTemp = ItemHWnd(IDC_TEMPSHOWTIME), TBM_SETRANGE, FALSE, MAKELONG(1, 60));
    SendMessage(hTemp, TBM_SETPOS, TRUE, icSettings.tmrShowIconsInAlwaysHide);
    SendMessage(hTemp, TBM_SETPAGESIZE, 0, 1);

    SendMessage(hTemp = ItemHWnd(ID_SCRSHOWDELAY), TBM_SETRANGE, FALSE, MAKELONG(1, 101));
    SendMessage(hTemp, TBM_SETPOS, TRUE, icSettings.tmrShowDelay);
    SendMessage(hTemp, TBM_SETPAGESIZE, 0, 1);
    SendMessage(hTemp = ItemHWnd(IDC_WPTIME), TBM_SETRANGE, FALSE, MAKELONG(1, 5*60));
    SendMessage(hTemp, TBM_SETPOS, TRUE, wptime);
    SendMessage(hTemp, TBM_SETPAGESIZE, 0, 1);
    CHAR          szMsg[18];
          
    wsprintf(szMsg, "%2d:%2d", wptime/60, 100+wptime%60);
    strcpy(szMsg+3, szMsg+4);
    SetWindowText(ItemHWnd(IDC_WPTIMETXT), szMsg);
    InvalidateRect(ItemHWnd(IDC_WPTIMETXT), 0, TRUE);

    ReInitializeTabs(hWnd);
    SendMessage(hWnd, ID_SETTINGCHANGE, SPI_SETDESKWALLPAPER, 0);
} 

BOOL Is95()
{
 // This routine returns true if the operating system is
 // before Win98 or Win 2000 because these older op syses dd not
 // have the Show Desktop feature.
    return (vi.dwMajorVersion == 4 && vi.dwMinorVersion == 0) // Windows NT 4.0 or Win95
        || (vi.dwMajorVersion < 4)                         // Windows NT 3.5
            ;

} 

BOOL Is2K()
{
 // This routine returns true if the operating system is at least Win2K
    return (vi.dwPlatformId = VER_PLATFORM_WIN32_NT        //
        && vi.dwMajorVersion >= 5)                         // Windows 2K or later
        ;
} 

BOOL IsXPatLeast()
{
 // This routine returns true if the operating system is XP or higher
    return (vi.dwMajorVersion > 5 || (vi.dwMajorVersion == 5 && vi.dwMinorVersion >= 1)) // Windows XP or higher
        ;
} 

BOOL IsXP()
{
 // This routine returns true if the operating system is XP
 // This is because for solid color text backgrounds
 // XP needs, well, XP really needs an enema
    return (vi.dwMajorVersion == 5 && vi.dwMinorVersion == 1) // Windows XP
        ;
} 
BOOL IsAtLeastVista()
{
     return (vi.dwMajorVersion >= 6  ) // Windows Vista+
        ;
} 

BOOL IsXP64()
{
 // This routine returns true if the operating system is XP
    return (vi.dwMajorVersion == 5 && vi.dwMinorVersion == 2) // Windows XP
        ;
} 

 // get child position relative to another window

void GetRelativeRect(UINT iBase,UINT iChild,LPRECT rect)
{
    RECT          rectBase;

    GetWindowRect(ItemHWnd(iChild), rect);
    GetWindowRect(ItemHWnd(iBase), &rectBase);
    OffsetRect(rect, -rectBase.left, -rectBase.top);       // get position relative to base
} 
